/*
 * generated by Xtext 2.17.0
 */
package org.xtext.example.mydsl.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import org.xtext.example.mydsl.scheme.Any;
import org.xtext.example.mydsl.scheme.Conditional;
import org.xtext.example.mydsl.scheme.Define;
import org.xtext.example.mydsl.scheme.Lambda;
import org.xtext.example.mydsl.scheme.Lista;
import org.xtext.example.mydsl.scheme.Model;
import org.xtext.example.mydsl.scheme.Operation;
import org.xtext.example.mydsl.scheme.Print;
import org.xtext.example.mydsl.scheme.SchemePackage;
import org.xtext.example.mydsl.services.SchemeGrammarAccess;

@SuppressWarnings("all")
public class SchemeSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private SchemeGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == SchemePackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case SchemePackage.ANY:
				sequence_Any(context, (Any) semanticObject); 
				return; 
			case SchemePackage.CONDITIONAL:
				sequence_Conditional(context, (Conditional) semanticObject); 
				return; 
			case SchemePackage.DEFINE:
				sequence_Define(context, (Define) semanticObject); 
				return; 
			case SchemePackage.LAMBDA:
				sequence_Lambda(context, (Lambda) semanticObject); 
				return; 
			case SchemePackage.LISTA:
				sequence_Lista(context, (Lista) semanticObject); 
				return; 
			case SchemePackage.MODEL:
				sequence_Model(context, (Model) semanticObject); 
				return; 
			case SchemePackage.OPERATION:
				sequence_Operation(context, (Operation) semanticObject); 
				return; 
			case SchemePackage.PRINT:
				sequence_Print(context, (Print) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Any returns Any
	 *
	 * Constraint:
	 *     (
	 *         anyID=ID | 
	 *         anyInt=INT | 
	 *         anyString=STRING | 
	 *         anyDefine=Define | 
	 *         anyLambda=Lambda | 
	 *         anyOperation=Operation | 
	 *         anyConditional=Conditional
	 *     )
	 */
	protected void sequence_Any(ISerializationContext context, Any semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Command returns Conditional
	 *     Conditional returns Conditional
	 *
	 * Constraint:
	 *     (cond=Any truthy=Any falsy=Any)
	 */
	protected void sequence_Conditional(ISerializationContext context, Conditional semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, SchemePackage.Literals.CONDITIONAL__COND) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, SchemePackage.Literals.CONDITIONAL__COND));
			if (transientValues.isValueTransient(semanticObject, SchemePackage.Literals.CONDITIONAL__TRUTHY) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, SchemePackage.Literals.CONDITIONAL__TRUTHY));
			if (transientValues.isValueTransient(semanticObject, SchemePackage.Literals.CONDITIONAL__FALSY) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, SchemePackage.Literals.CONDITIONAL__FALSY));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getConditionalAccess().getCondAnyParserRuleCall_2_0(), semanticObject.getCond());
		feeder.accept(grammarAccess.getConditionalAccess().getTruthyAnyParserRuleCall_3_0(), semanticObject.getTruthy());
		feeder.accept(grammarAccess.getConditionalAccess().getFalsyAnyParserRuleCall_4_0(), semanticObject.getFalsy());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Command returns Define
	 *     Define returns Define
	 *
	 * Constraint:
	 *     (varUm=STRING varValue=INT)
	 */
	protected void sequence_Define(ISerializationContext context, Define semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, SchemePackage.Literals.DEFINE__VAR_UM) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, SchemePackage.Literals.DEFINE__VAR_UM));
			if (transientValues.isValueTransient(semanticObject, SchemePackage.Literals.DEFINE__VAR_VALUE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, SchemePackage.Literals.DEFINE__VAR_VALUE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getDefineAccess().getVarUmSTRINGTerminalRuleCall_2_0(), semanticObject.getVarUm());
		feeder.accept(grammarAccess.getDefineAccess().getVarValueINTTerminalRuleCall_3_0(), semanticObject.getVarValue());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Command returns Lambda
	 *     Lambda returns Lambda
	 *
	 * Constraint:
	 *     param+=Any+
	 */
	protected void sequence_Lambda(ISerializationContext context, Lambda semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Command returns Lista
	 *     Lista returns Lista
	 *
	 * Constraint:
	 *     numeros+=INT+
	 */
	protected void sequence_Lista(ISerializationContext context, Lista semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Model returns Model
	 *
	 * Constraint:
	 *     commands+=Command+
	 */
	protected void sequence_Model(ISerializationContext context, Model semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Command returns Operation
	 *     Operation returns Operation
	 *
	 * Constraint:
	 *     ((arit_op=ARITHMETIC_OPERATORS | log_op=LOGICAL_OPERATORS | rel_op=RELATIONAL_OPERATORS) valueUm=INT valueDois=INT)
	 */
	protected void sequence_Operation(ISerializationContext context, Operation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Command returns Print
	 *     Print returns Print
	 *
	 * Constraint:
	 *     string=STRING
	 */
	protected void sequence_Print(ISerializationContext context, Print semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, SchemePackage.Literals.PRINT__STRING) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, SchemePackage.Literals.PRINT__STRING));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getPrintAccess().getStringSTRINGTerminalRuleCall_1_0(), semanticObject.getString());
		feeder.finish();
	}
	
	
}
